<template>
  <q-card :square="!isDesktopPlatform">
    <div
      v-if="loading"
      class="column flex-center"
    >
      <q-card-section>
        <q-spinner-dots
          color="primary"
          size="24px"
        />
      </q-card-section>
    </div>

    <template v-else-if="plotConstraints">
      <template v-if="constraints.length > 0">
        <q-list separator>
          <template
            v-for="constraint in constraints"
            :key="constraint.id"
          >
            <PlotConstraintItem
              :constraint="constraint"
              add-go-to-details-button
            />
          </template>
        </q-list>
      </template>

      <div v-else>
        <q-card-section>
          <span
            class="text-body2 text-grey"
          >
            <translate>No constraints</translate>
          </span>
        </q-card-section>
      </div>
    </template>
  </q-card>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import PlotConstraintItem from 'src/pages/holding-campaign/plot/components/PlotConstraintItem'
import queryPlotConstraints from 'src/pages/holding-campaign/plot/graphql/queryPlotConstraints'

export default {
  name: 'PlotConstraintsCard',
  mixins: [
    PlatformMixin
  ],
  components: {
    PlotConstraintItem
  },
  props: {
    plotId: {
      type: Number,
      required: true
    }
  },
  computed: {
    loading () {
      return !this.plotConstraints && this.$apollo.queries.plotConstraints.loading
    },
    constraints () {
      const constraints = this.plotConstraints?.filter(constraint => constraint.description !== null)
        .map(constraint => ({
          ...constraint,
          description: typeof constraint.description === 'string' ? JSON.parse(constraint.description) : constraint.description
        }))
        .map(constraint => ({
          ...constraint,
          label: constraint?.description?.management_restriction_or_regulation_zone_name || constraint?.description?.protected_site_name || constraint?.description?.water_course_name || constraint?.description?.surface_water_name,
          value: constraint?.description?.plot_pct_in_management_restriction_or_regulation_zone || constraint?.description?.plot_pct_in_protected_site || -constraint?.description?.distance_to_water_course || -constraint?.description?.distance_to_surface_water
        }))
        .sort((a, b) => {
          if (b.name === a.name) {
            if (b.label === a.label) {
              return b.value - a.value
            } else if (b.label < a.label) {
              return -1
            } else {
              return 1
            }
          } else if (b.name < a.name) {
            return -1
          } else {
            return 1
          }
        })

      const statistics = {}
      constraints.forEach(constraint => {
        if (!statistics[constraint.name]) {
          statistics[constraint.name] = {}
        }
        if (!statistics[constraint.name][constraint.label] || statistics[constraint.name][constraint.label].value < constraint.value) {
          statistics[constraint.name][constraint.label] = {
            constraint,
            value: constraint.value
          }
        }
      })

      const cleanedUpConstraints = []
      for (const namelabels of Object.values(statistics)) {
        for (const labelConstraint of Object.values(namelabels)) {
          cleanedUpConstraints.push(labelConstraint.constraint)
        }
      }

      return cleanedUpConstraints
    }
  },
  apollo: {
    plotConstraints: {
      query: queryPlotConstraints,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      }
    }
  }
}
</script>
